--- a/lib/GnuPG/Interface.pm
+++ b/lib/GnuPG/Interface.pm
@@ -335,6 +335,11 @@
 }
 
 
+sub unescape_string {
+  my($str) = splice(@_);
+  $str =~ s/\\x(..)/chr(hex($1))/eg;
+  return $str;
+}
 
 ###################################################################
 
@@ -451,7 +456,7 @@
 
             $current_signed_item = GnuPG::UserId->new(
                 validity  => $user_id_validity,
-                as_string => $user_id_string,
+                as_string => unescape_string($user_id_string),
             );
 
             $current_key->push_user_ids($current_signed_item);
@@ -472,7 +477,7 @@
                 algo_num       => $algo_num,
                 hex_id         => $hex_key_id,
                 date_string    => $signature_date_string,
-                user_id_string => $user_id_string,
+                user_id_string => unescape_string($user_id_string),
             );
 
             if ( $current_signed_item->isa('GnuPG::UserId') ) {
@@ -490,7 +495,7 @@
 
             $current_signed_item = GnuPG::UserId->new(
                 validity  => $validity,
-                as_string => $user_id_string,
+                as_string => unescape_string($user_id_string),
             );
 
             $current_key->push_user_ids($current_signed_item);
